#include<stdio.h>
#include<stdlib.h>
#include<time.h>
unsigned char simulate_a_classroom(int n);
int main(int argc, char *argv[]){
	int seed,i,n,m,cpt_collisions;
	if(argc<3){
		printf("USAGE : birthday n m \nn: nb of students\nm: nb of runs during the experiment\n");
		return -1;
	}
	n=atoi(argv[1]);
	m=atoi(argv[2]);
	seed=time(NULL);
	srand(seed);
	cpt_collisions=0;
	for(i=0;i<m;i++){
		cpt_collisions+=simulate_a_classroom(n);
	}
	printf("Probabilite de collision = %f \n",100.0*cpt_collisions/m);
	return 0;
}
// n is the number of students
// this function returns 1 if there is a collision, 0 otherwise
unsigned char simulate_a_classroom(int n){ 
	int i,j;
	unsigned char *v_birthdays; // vector containing all the possible birthdays
	v_birthdays=(unsigned char*)malloc(365*sizeof(unsigned char));
	for(i=0;i<365;i++){
		v_birthdays[i]=0;
	}
	for(i=0;i<n;i++){
		j=rand()%365; // not uniform... to be improved
		if(v_birthdays[j]==0){
			v_birthdays[j]=1;
		}
		else{
			return 1;
		}
	}
	free(v_birthdays);
	return 0;
}